import networkx as nx

g = nx.Graph()

g.add_edge('a','b',weight=0.1)
g.add_edge('b','c',weight=1.5)
g.add_edge('a','c',weight=1.0)
g.add_edge('c','d',weight=2.2)

print nx.shortest_path(g,'b','d')
['b', 'c', 'd']

print nx.shortest_path(g,'b','d',weight='weight')
['b', 'a', 'c', 'd']

g.number_of_nodes()  # also g.order()
4
g.order()  # also g.size()
4

g.nodes()
['a', 'c', 'b', 'd']
g.edges()
[('a', 'c'), ('a', 'b'), ('c', 'b'), ('c', 'd')]

g.edges('b')
[('b', 'a'), ('b', 'c')]
g.edges('a')
[('a', 'c'), ('a', 'b')]

g.degree('a')
2
g.neighbors('c')
['a', 'b', 'd']

import pylab as plt
plt.ion()
nx.draw(g)
plt.show()




mg = nx.MultiGraph()
mg.add_weighted_edges_from([(1,2, .5), (1,2, .75), (2,3, .5)])
mg.degree()
{1: 2, 2: 3, 3: 1}
mg.degree(weight='weight')
{1: 1.25, 2: 1.75, 3: 0.5}


dg = nx.DiGraph()
dg.add_weighted_edges_from([(1,4,0.5), (3,1,0.75)])
dg.degree(1,weight='weight')
1.25
dg.successors(1)
[4]
dg.predecessors(1)
[3]


petersen=nx.petersen_graph()


K_5=nx.complete_graph(5)
nx.draw(K_5)

K_3_5=nx.complete_bipartite_graph(3,5)
nx.draw(K_3_5)

barbell=nx.barbell_graph(10,10)
nx.draw(barbell)

lollipop=nx.lollipop_graph(10,20)
nx.draw(lollipop)


er=nx.erdos_renyi_graph(100,0.15)
nx.draw(er)

ws=nx.watts_strogatz_graph(30,3,0.1)
nx.draw(ws)

ba=nx.barabasi_albert_graph(100,5)
nx.draw(ba)

red=nx.random_lobster(100,0.9,0.9)
nx.draw(red)






import networkx as nx
import pylab as plt
g = nx.erdos_renyi_graph(100,0.15)
nx.draw(g)
nx.draw_random(g)
nx.draw_circular(g)
nx.draw_spectral(g)
plt.savefig('graph.png')


N,K = g.order(), g.size()
avg_deg = float(K)/N
print "Nodes: ", N
print "Edges: ", K
print "Average degree: ", avg_deg

g.in_degrees()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
AttributeError: 'Graph' object has no attribute 'in_degrees'

diG=nx.DiGraph(g) #create a directed graph
# account for in/out-going connections...
in_degrees = diG.in_degree() # dictionary node:degree
out_degrees = diG.out_degree() # dictionary node:degree
in_values = sorted(set(in_degrees.values()))
out_values = sorted(set(out_degrees.values()))
# put data in histogram-form
in_hist = [in_degrees.values().count(x) for x in in_values]
out_hist = [out_degrees.values().count(x) for x in out_values]

# plot
plt.figure()
plt.plot(in_values,in_hist,'ro-') # in-degree
plt.plot(out_values,out_hist,'bv-') # out-degree
plt.legend(['In-degree','Out-degree'])
plt.xlabel('Degree')
plt.ylabel('Number of nodes')
plt.title('Example of a random network')
plt.savefig('network_degree_distribution.pdf')
plt.close()




import numpy as np
g_ud = diG.to_undirected()
# Clustering coefficient of node 0
print nx.clustering(g_ud, 0)
# Clustering coefficient of all nodes (in a dictionary)
clust_coefficients = nx.clustering(g_ud)
# Average clustering coefficient
ccs = nx.clustering(g_ud)
avg_clust = sum(ccs.values()) / len(ccs)

plt.plot(ccs.keys(),ccs.values())
plt.plot(ccs.keys(),np.ones(len(ccs))*avg_clust)


# main connected component
g_components = nx.connected_component_subgraphs(g_ud)
g_mc = g_components[0]
# Betweenness centrality
bet_cen = nx.betweenness_centrality(g_mc)
# Closeness centrality
clo_cen = nx.closeness_centrality(g_mc)
# Eigenvector centrality
eig_cen = nx.eigenvector_centrality(g_mc)

