import networkx as nx
import pylab as plt

scinetG = nx.read_edgelist("scinet_data.txt",
	comments='#',
	create_using=nx.MultiDiGraph(),
	delimiter='  ',
	nodetype=str,data=(('weight',float),) )

plt.ion()
nx.draw(scinetG)


plt.figure()
plt.axis('off')

cutOff=0.001
elarge=[(u,v) for (u,v,d) in scinetG.edges(data=True) if d['weight'] > cutOff]
esmall=[(u,v) for (u,v,d) in scinetG.edges(data=True) if d['weight'] <= cutOff]

#try different ones from the ones below...
#pos=nx.spring_layout(scinetG) # positions for all nodes
pos=nx.graphviz_layout(scinetG)
#pos=nx.shell_layout(scinetG)
#pos=nx.random_layout(scinetG)
#pos=nx.spectral_layout(scinetG)

# nodes
nx.draw_networkx_nodes(scinetG,pos,
#                node_color=nodeType.values(),
#                node_size=tmW.values(),
                cmap=plt.cm.Reds, alpha=0.7)

# edges
color_edges=range(scinetG.number_of_edges())
nx.draw_networkx_edges(scinetG,pos,edgelist=elarge,
                    width=3,alpha=0.7,edge_color='r',
		    with_labels='True',edge_cmap=plt.cm.Blues)        
nx.draw_networkx_edges(scinetG,pos,edgelist=esmall,
                    width=2,alpha=0.4,edge_color='b',style='dotted')

# labels
try:
	nx.draw_networkx_labels(scinetG,pos,labels,font_size=13,
		font_family='sans-serif', font_color='Indigo')
except:
	nx.draw_networkx_labels(scinetG,pos,font_size=13,font_family='sans-serif')

